/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

import{isHTMLElement as t,addClassNamesToElement as e,removeClassNamesFromElement as n,$getAdjacentCaret as r,mergeRegister as o}from"@lexical/utils";import{ElementNode as i,$createParagraphNode as s,$isTextNode as l,$isTabNode as u,$createTabNode as c,$createLineBreakNode as g,$applyNodeReplacement as a,TextNode as p,$getSiblingCaret as f,$isLineBreakNode as h,$createTextNode as d,$getNodeByKey as m,$getSelection as y,$isRangeSelection as x,INDENT_CONTENT_COMMAND as S,OUTDENT_CONTENT_COMMAND as _,INSERT_TAB_COMMAND as v,KEY_ARROW_UP_COMMAND as T,MOVE_TO_START as N,KEY_TAB_COMMAND as C,COMMAND_PRIORITY_LOW as b,$insertNodes as j,KEY_ARROW_DOWN_COMMAND as w,MOVE_TO_END as P}from"lexical";import"prismjs";import"prismjs/components/prism-clike.js";import"prismjs/components/prism-javascript.js";import"prismjs/components/prism-markup.js";import"prismjs/components/prism-markdown.js";import"prismjs/components/prism-c.js";import"prismjs/components/prism-css.js";import"prismjs/components/prism-objectivec.js";import"prismjs/components/prism-sql.js";import"prismjs/components/prism-powershell.js";import"prismjs/components/prism-python.js";import"prismjs/components/prism-rust.js";import"prismjs/components/prism-swift.js";import"prismjs/components/prism-typescript.js";import"prismjs/components/prism-java.js";import"prismjs/components/prism-cpp.js";"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function O(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}var k=O((function(t){const e=new URL("https://lexical.dev/docs/error"),n=new URLSearchParams;n.append("code",t);for(let t=1;t<arguments.length;t++)n.append("v",arguments[t]);throw e.search=n.toString(),Error(`Minified Lexical error #${t}; visit ${e.toString()} for the full message or use the non-minified dev environment for full errors and additional helpful warnings.`)}));const L=globalThis.Prism||window.Prism,A=t=>{try{return!!t&&L.languages.hasOwnProperty(t)}catch(t){return!1}};function H(e,n){for(const r of e.childNodes){if(t(r)&&r.tagName===n)return!0;H(r,n)}return!1}const M="data-language",D="data-highlight-language";class z extends i{static getType(){return"code"}static clone(t){return new z(t.__language,t.__key)}constructor(t,e){super(e),this.__language=t||void 0,this.__isSyntaxHighlightSupported=A(t)}createDOM(t){const n=document.createElement("code");e(n,t.theme.code),n.setAttribute("spellcheck","false");const r=this.getLanguage();return r&&(n.setAttribute(M,r),this.getIsSyntaxHighlightSupported()&&n.setAttribute(D,r)),n}updateDOM(t,e,n){const r=this.__language,o=t.__language;return r?r!==o&&(e.setAttribute(M,r),this.__isSyntaxHighlightSupported&&e.setAttribute(D,r)):o&&(e.removeAttribute(M),t.__isSyntaxHighlightSupported&&e.removeAttribute(D)),!1}exportDOM(t){const n=document.createElement("pre");e(n,t._config.theme.code),n.setAttribute("spellcheck","false");const r=this.getLanguage();return r&&(n.setAttribute(M,r),this.getIsSyntaxHighlightSupported()&&n.setAttribute(D,r)),{element:n}}static importDOM(){return{code:t=>null!=t.textContent&&(/\r?\n/.test(t.textContent)||H(t,"BR"))?{conversion:F,priority:1}:null,div:()=>({conversion:B,priority:1}),pre:()=>({conversion:F,priority:0}),table:t=>q(t)?{conversion:R,priority:3}:null,td:t=>{const e=t,n=e.closest("table");return e.classList.contains("js-file-line")||n&&q(n)?{conversion:I,priority:3}:null},tr:t=>{const e=t.closest("table");return e&&q(e)?{conversion:I,priority:3}:null}}}static importJSON(t){return J().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setLanguage(t.language)}exportJSON(){return{...super.exportJSON(),language:this.getLanguage()}}insertNewAfter(t,e=!0){const n=this.getChildren(),r=n.length;if(r>=2&&"\n"===n[r-1].getTextContent()&&"\n"===n[r-2].getTextContent()&&t.isCollapsed()&&t.anchor.key===this.__key&&t.anchor.offset===r){n[r-1].remove(),n[r-2].remove();const t=s();return this.insertAfter(t,e),t}const{anchor:o,focus:i}=t,a=(o.isBefore(i)?o:i).getNode();if(l(a)){let t=rt(a);const e=[];for(;;)if(u(t))e.push(c()),t=t.getNextSibling();else{if(!et(t))break;{let n=0;const r=t.getTextContent(),o=t.getTextContentSize();for(;n<o&&" "===r[n];)n++;if(0!==n&&e.push(tt(" ".repeat(n))),n!==o)break;t=t.getNextSibling()}}const n=a.splitText(o.offset)[0],r=0===o.offset?0:1,i=n.getIndexWithinParent()+r,s=a.getParentOrThrow(),l=[g(),...e];s.splice(i,0,l);const p=e[e.length-1];p?p.select():0===o.offset?n.selectPrevious():n.getNextSibling().selectNext(0,0)}if(E(a)){const{offset:e}=t.anchor;a.splice(e,0,[g()]),a.select(e+1,e+1)}return null}canIndent(){return!1}collapseAtStart(){const t=s();return this.getChildren().forEach((e=>t.append(e))),this.replace(t),!0}setLanguage(t){const e=this.getWritable();return e.__language=t||void 0,e.__isSyntaxHighlightSupported=A(t),e}getLanguage(){return this.getLatest().__language}getIsSyntaxHighlightSupported(){return this.getLatest().__isSyntaxHighlightSupported}}function J(t){return a(new z(t))}function E(t){return t instanceof z}function F(t){return{node:J(t.getAttribute(M))}}function B(t){const e=t,n=K(e);return n||function(t){let e=t.parentElement;for(;null!==e;){if(K(e))return!0;e=e.parentElement}return!1}(e)?{node:n?J():null}:{node:null}}function R(){return{node:J()}}function I(){return{node:null}}function K(t){return null!==t.style.fontFamily.match("monospace")}function q(t){return t.classList.contains("js-file-line-container")}const U="javascript",W={c:"C",clike:"C-like",cpp:"C++",css:"CSS",html:"HTML",java:"Java",js:"JavaScript",markdown:"Markdown",objc:"Objective-C",plain:"Plain Text",powershell:"PowerShell",py:"Python",rust:"Rust",sql:"SQL",swift:"Swift",typescript:"TypeScript",xml:"XML"},$={cpp:"cpp",java:"java",javascript:"js",md:"markdown",plaintext:"plain",python:"py",text:"plain",ts:"typescript"};function Q(t){return $[t]||t}function X(t){const e=Q(t);return W[e]||e}const G=()=>U,V=()=>Object.keys(L.languages).filter((t=>"function"!=typeof L.languages[t])).sort();class Y extends p{constructor(t="",e,n){super(t,n),this.__highlightType=e}static getType(){return"code-highlight"}static clone(t){return new Y(t.__text,t.__highlightType||void 0,t.__key)}getHighlightType(){return this.getLatest().__highlightType}setHighlightType(t){const e=this.getWritable();return e.__highlightType=t||void 0,e}canHaveFormat(){return!1}createDOM(t){const n=super.createDOM(t),r=Z(t.theme,this.__highlightType);return e(n,r),n}updateDOM(t,r,o){const i=super.updateDOM(t,r,o),s=Z(o.theme,t.__highlightType),l=Z(o.theme,this.__highlightType);return s!==l&&(s&&n(r,s),l&&e(r,l)),i}static importJSON(t){return tt().updateFromJSON(t)}updateFromJSON(t){return super.updateFromJSON(t).setHighlightType(t.highlightType)}exportJSON(){return{...super.exportJSON(),highlightType:this.getHighlightType()}}setFormat(t){return this}isParentRequired(){return!0}createParentElementNode(){return J()}}function Z(t,e){return e&&t&&t.codeHighlight&&t.codeHighlight[e]}function tt(t="",e){return a(new Y(t,e))}function et(t){return t instanceof Y}function nt(t,e){let n=t;for(let o=f(t,e);o&&(et(o.origin)||u(o.origin));o=r(o))n=o.origin;return n}function rt(t){return nt(t,"previous")}function ot(t){return nt(t,"next")}const it={defaultLanguage:U,tokenize(t,e){return L.tokenize(t,L.languages[e||""]||L.languages[this.defaultLanguage])}};function st(t,e){let n=null,r=null,o=t,i=e,s=t.getTextContent();for(;;){if(0===i){if(o=o.getPreviousSibling(),null===o)break;if(et(o)||u(o)||h(o)||k(167),h(o)){n={node:o,offset:1};break}i=Math.max(0,o.getTextContentSize()-1),s=o.getTextContent()}else i--;const t=s[i];et(o)&&" "!==t&&(r={node:o,offset:i})}if(null!==r)return r;let l=null;if(e<t.getTextContentSize())et(t)&&(l=t.getTextContent()[e]);else{const e=t.getNextSibling();et(e)&&(l=e.getTextContent()[0])}if(null!==l&&" "!==l)return n;{const r=function(t,e){let n=t,r=e,o=t.getTextContent(),i=t.getTextContentSize();for(;;){if(!et(n)||r===i){if(n=n.getNextSibling(),null===n||h(n))return null;et(n)&&(r=0,o=n.getTextContent(),i=n.getTextContentSize())}if(et(n)){if(" "!==o[r])return{node:n,offset:r};r++}}}(t,e);return null!==r?r:n}}function lt(t){const e=ot(t);return h(e)&&k(168),e}function ut(t,e,n){const r=t.getParent();E(r)?at(r,e,n):et(t)&&t.replace(d(t.__text))}function ct(t,e){const n=e.getElementByKey(t.getKey());if(null===n)return;const r=t.getChildren(),o=r.length;if(o===n.__cachedChildrenLength)return;n.__cachedChildrenLength=o;let i="1",s=1;for(let t=0;t<o;t++)h(r[t])&&(i+="\n"+ ++s);n.setAttribute("data-gutter",i)}const gt=new Set;function at(t,e,n){const r=t.getKey();gt.has(r)||(gt.add(r),void 0===t.getLanguage()&&t.setLanguage(n.defaultLanguage),e.update((()=>{!function(t,e){const n=m(t);if(!E(n)||!n.isAttached())return;const r=y();if(!x(r))return void e();const o=r.anchor,i=o.offset,s="element"===o.type&&h(n.getChildAtIndex(o.offset-1));let u=0;if(!s){const t=o.getNode();u=i+t.getPreviousSiblings().reduce(((t,e)=>t+e.getTextContentSize()),0)}if(!e())return;if(s)return void o.getNode().select(i,i);n.getChildren().some((t=>{const e=l(t);if(e||h(t)){const n=t.getTextContentSize();if(e&&n>=u)return t.select(u,u),!0;u-=n}return!1}))}(r,(()=>{const e=m(r);if(!E(e)||!e.isAttached())return!1;const o=e.getTextContent(),i=pt(n.tokenize(o,e.getLanguage()||n.defaultLanguage)),s=function(t,e){let n=0;for(;n<t.length&&ft(t[n],e[n]);)n++;const r=t.length,o=e.length,i=Math.min(r,o)-n;let s=0;for(;s<i;)if(s++,!ft(t[r-s],e[o-s])){s--;break}const l=n,u=r-s,c=e.slice(n,o-s);return{from:l,nodesForReplacement:c,to:u}}(e.getChildren(),i),{from:l,to:u,nodesForReplacement:c}=s;return!(l===u&&!c.length)&&(t.splice(l,u-l,c),!0)}))}),{onUpdate:()=>{gt.delete(r)},skipTransforms:!0}))}function pt(t,e){const n=[];for(const r of t)if("string"==typeof r){const t=r.split(/(\n|\t)/),o=t.length;for(let r=0;r<o;r++){const o=t[r];"\n"===o||"\r\n"===o?n.push(g()):"\t"===o?n.push(c()):o.length>0&&n.push(tt(o,e))}}else{const{content:t}=r;"string"==typeof t?n.push(...pt([t],r.type)):Array.isArray(t)&&n.push(...pt(t,r.type))}return n}function ft(t,e){return et(t)&&et(e)&&t.__text===e.__text&&t.__highlightType===e.__highlightType||u(t)&&u(e)||h(t)&&h(e)}function ht(t){if(!x(t))return!1;const e=t.anchor.getNode(),n=t.focus.getNode();if(e.is(n)&&E(e))return!0;const r=e.getParent();return E(r)&&r.is(n.getParent())}function dt(t){const e=t.getNodes(),n=[[]];if(1===e.length&&E(e[0]))return n;let r=n[0];for(let t=0;t<e.length;t++){const o=e[t];et(o)||u(o)||h(o)||k(169),h(o)?0!==t&&r.length>0&&(r=[],n.push(r)):r.push(o)}return n}function mt(t){const e=y();if(!x(e)||!ht(e))return!1;const n=dt(e),r=n.length;if(n.length>1){for(let e=0;e<r;e++){const r=n[e];if(r.length>0){let n=r[0];0===e&&(n=rt(n)),null!==n&&(t===S?n.insertBefore(c()):u(n)&&n.remove())}}return!0}const o=e.getNodes()[0];if(E(o)||et(o)||u(o)||h(o)||k(171),E(o))return t===S&&e.insertNodes([c()]),!0;const i=rt(o);return t===S?h(i)?i.insertAfter(c()):i.insertBefore(c()):u(i)&&i.remove(),!0}function yt(t,e){const n=y();if(!x(n))return!1;const{anchor:r,focus:o}=n,i=r.offset,s=o.offset,l=r.getNode(),c=o.getNode(),g=t===T;if(!ht(n)||!et(l)&&!u(l)||!et(c)&&!u(c))return!1;if(!e.altKey){if(n.isCollapsed()){const t=l.getParentOrThrow();if(g&&0===i&&null===l.getPreviousSibling()){if(null===t.getPreviousSibling())return t.selectPrevious(),e.preventDefault(),!0}else if(!g&&i===l.getTextContentSize()&&null===l.getNextSibling()){if(null===t.getNextSibling())return t.selectNext(),e.preventDefault(),!0}}return!1}let a,p;if(l.isBefore(c)?(a=rt(l),p=ot(c)):(a=rt(c),p=ot(l)),null==a||null==p)return!1;const f=a.getNodesBetween(p);for(let t=0;t<f.length;t++){const e=f[t];if(!et(e)&&!u(e)&&!h(e))return!1}e.preventDefault(),e.stopPropagation();const d=g?a.getPreviousSibling():p.getNextSibling();if(!h(d))return!0;const m=g?d.getPreviousSibling():d.getNextSibling();if(null==m)return!0;const S=et(m)||u(m)||h(m)?g?rt(m):ot(m):null;let _=null!=S?S:m;return d.remove(),f.forEach((t=>t.remove())),t===T?(f.forEach((t=>_.insertBefore(t))),_.insertBefore(d)):(_.insertAfter(d),_=d,f.forEach((t=>{_.insertAfter(t),_=t}))),n.setTextNodeRange(l,i,c,s),!0}function xt(t,e){const n=y();if(!x(n))return!1;const{anchor:r,focus:o}=n,i=r.getNode(),s=o.getNode(),l=t===N;if(!ht(n)||!et(i)&&!u(i)||!et(s)&&!u(s))return!1;if(l){const t=st(s,o.offset);if(null!==t){const{node:e,offset:r}=t;h(e)?e.selectNext(0,0):n.setTextNodeRange(e,r,e,r)}else s.getParentOrThrow().selectStart()}else{lt(s).select()}return e.preventDefault(),e.stopPropagation(),!0}function St(t,e){if(!t.hasNodes([z,Y]))throw new Error("CodeHighlightPlugin: CodeNode or CodeHighlightNode not registered on editor");return null==e&&(e=it),o(t.registerMutationListener(z,(e=>{t.update((()=>{for(const[n,r]of e)if("destroyed"!==r){const e=m(n);null!==e&&ct(e,t)}}))}),{skipInitialization:!1}),t.registerNodeTransform(z,(n=>at(n,t,e))),t.registerNodeTransform(p,(n=>ut(n,t,e))),t.registerNodeTransform(Y,(n=>ut(n,t,e))),t.registerCommand(C,(e=>{const n=function(t){const e=y();if(!x(e)||!ht(e))return null;const n=t?_:S,r=t?_:v;if(dt(e).length>1)return n;const o=e.getNodes()[0];if(E(o)||et(o)||u(o)||h(o)||k(170),E(o))return n;const i=rt(o),s=ot(o),l=e.anchor,c=e.focus;let g,a;return c.isBefore(l)?(g=c,a=l):(g=l,a=c),null!==i&&null!==s&&g.key===i.getKey()&&0===g.offset&&a.key===s.getKey()&&a.offset===s.getTextContentSize()?n:r}(e.shiftKey);return null!==n&&(e.preventDefault(),t.dispatchCommand(n,void 0),!0)}),b),t.registerCommand(v,(()=>!!ht(y())&&(j([c()]),!0)),b),t.registerCommand(S,(t=>mt(S)),b),t.registerCommand(_,(t=>mt(_)),b),t.registerCommand(T,(t=>{const e=y();if(!x(e))return!1;const{anchor:n}=e,r=n.getNode();return!!ht(e)&&(e.isCollapsed()&&0===n.offset&&null===r.getPreviousSibling()&&E(r.getParentOrThrow())?(t.preventDefault(),!0):yt(T,t))}),b),t.registerCommand(w,(t=>{const e=y();if(!x(e))return!1;const{anchor:n}=e,r=n.getNode();return!!ht(e)&&(e.isCollapsed()&&n.offset===r.getTextContentSize()&&null===r.getNextSibling()&&E(r.getParentOrThrow())?(t.preventDefault(),!0):yt(w,t))}),b),t.registerCommand(N,(t=>xt(N,t)),b),t.registerCommand(P,(t=>xt(P,t)),b))}const _t=rt,vt=ot,Tt=lt,Nt=st;export{tt as $createCodeHighlightNode,J as $createCodeNode,lt as $getEndOfCodeInLine,rt as $getFirstCodeNodeOfLine,ot as $getLastCodeNodeOfLine,st as $getStartOfCodeInLine,et as $isCodeHighlightNode,E as $isCodeNode,W as CODE_LANGUAGE_FRIENDLY_NAME_MAP,$ as CODE_LANGUAGE_MAP,Y as CodeHighlightNode,z as CodeNode,U as DEFAULT_CODE_LANGUAGE,it as PrismTokenizer,V as getCodeLanguages,G as getDefaultCodeLanguage,Tt as getEndOfCodeInLine,_t as getFirstCodeNodeOfLine,X as getLanguageFriendlyName,vt as getLastCodeNodeOfLine,Nt as getStartOfCodeInLine,Q as normalizeCodeLang,St as registerCodeHighlighting};
